within Modelica_DeviceDrivers.InputDevices;
class Keyboard "A driver accessing the keyboard."

extends Modelica_DeviceDrivers.Utilities.Icons.DriverIcon;
function getKey "reads data from a single key of the keyboard"
input Integer keyCode "Key code";
output Integer keyState "Key state";

external "C" KEY_getKey(keyCode, keyState);

annotation (Include="
#define VOID void
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;
typedef unsigned __int64 u_int64;
#include <winsock2.h>//for compatibility reasons 
#include <windows.h>  
void KEY_getKey(int iKeyCode,int * piKeyState)
{
        //getting state of interesting keys
        if(GetAsyncKeyState(iKeyCode)) piKeyState[0] = 1;
                        else piKeyState[0] = 0;
        
}
 
 
");
end getKey;

function getData "reads data from several keyboard keys"

output Integer KeyCode[10] "Key values";

external "C" KEY_getData(KeyCode);

annotation (Include="
#define VOID void
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;
typedef unsigned __int64 u_int64;
#include <winsock2.h>//for compatibility reasons 
#include <windows.h>  
void KEY_getData(int * piKeyState)
{
        //getting state of interesting keys
        if(GetAsyncKeyState(VK_UP)) piKeyState[0] = 1;
                        else piKeyState[0] = 0;
        if(GetAsyncKeyState(VK_DOWN)) piKeyState[1] = 1;
                else piKeyState[1] = 0;
        if(GetAsyncKeyState(VK_RIGHT)) piKeyState[2] = 1;
                else piKeyState[2] = 0;
        if(GetAsyncKeyState(VK_LEFT)) piKeyState[3] = 1;
                else piKeyState[3] = 0;
        if(GetAsyncKeyState(VK_RETURN)) piKeyState[4] = 1;
                else piKeyState[4] = 0;
        if(GetAsyncKeyState(VK_SPACE)) piKeyState[5] = 1;
                else piKeyState[5] = 0;
        if(GetAsyncKeyState(VK_F9)) piKeyState[6] = 1;
                else piKeyState[6] = 0;
        if(GetAsyncKeyState(VK_F10)) piKeyState[7] = 1;
                else piKeyState[7] = 0;
        if(GetAsyncKeyState(VK_F11)) piKeyState[8] = 1;
                else piKeyState[8] = 0;
        if(GetAsyncKeyState(VK_F12)) piKeyState[9] = 1;
                else piKeyState[9] = 0;
}
 
");
end getData;

end Keyboard;
