within Modelica_DeviceDrivers.OperatingSystem;
function setProcessPriority
input Integer priority "Simulation process priority (-2(lowest)..2(realtime))";

external "C" OS_setPriority(priority);
annotation(Include = "
#ifndef MDDSETPRIORITY
#define MDDSETPRIORITY
#define VOID void
typedef char CHAR;
typedef short SHORT;
typedef long LONG;
typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;
typedef unsigned __int64 u_int64;
#include <winsock2.h>//for compatibility reasons 
#include <windows.h>
#include  \"ModelicaUtilities.h\"  
 
void OS_setPriority(int priority)
{
  ModelicaFormatMessage(\"ProcessPriority: %d!!\\n\",priority);
  switch(priority)
  {
    case -2:
      ModelicaFormatMessage(\"setting...\\n\");
      if(SetPriorityClass(GetCurrentProcess(),IDLE_PRIORITY_CLASS))
        ModelicaFormatMessage(\"ProcessPriority set to idle.\\n\");
    break;
    
    case -1:
      ModelicaFormatMessage(\"setting...\\n\");      
      if(SetPriorityClass(GetCurrentProcess(),BELOW_NORMAL_PRIORITY_CLASS))
        ModelicaFormatMessage(\"ProcessPriority set to below normal.\\n\");
    break;
 
    case 0:
      ModelicaFormatMessage(\"setting...\\n\");
      if(SetPriorityClass(GetCurrentProcess(),NORMAL_PRIORITY_CLASS))
        ModelicaFormatMessage(\"ProcessPriority set to normal.\\n\");
    break;
 
    case 1:
      ModelicaFormatMessage(\"setting...\\n\");
      if(SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS))
        ModelicaFormatMessage(\"ProcessPriority set to high.\\n\");
    break;
 
    case 2:
      ModelicaFormatMessage(\"setting...\\n\");
      if(SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS))
        ModelicaFormatMessage(\"ProcessPriority set to realtime.\\n\");
    break;
 
    default:
      ModelicaFormatMessage(\"setting...\\n\");
      if(SetPriorityClass(GetCurrentProcess(),NORMAL_PRIORITY_CLASS))
        ModelicaFormatMessage(\"ProcessPriority set to normal.\\n\");
    break;
    
   
 
  }
 
  ModelicaFormatMessage(\"LastError: %d\\n\",GetLastError());
} 
 
 
#endif
 
");
end setProcessPriority;
